%This script runs the provided approx_ode function to obtain the
%approximate solution and calculates and tabulates the global error at each
%time t_i. In addition the script also verifies that the convergence of
%Euler's method/Second order Taylor methood is first order (second order) 
%by comparing the ratio of the solutions for
%decreasing values of h (the size of the time steps)
%PC MA428 10/25/2015
approx_sol=[];
true_sol=[];
n=10;
a=1;
b=6;
initial_value =1.0;
test_case ='F';
approx_sol = approx_ode('f',a,b,initial_value,n,test_case);
%calculate the true solution
nodes =  linspace(1,6,n+1);
true_sol = feval('true_solution',nodes);
error = abs(approx_sol-true_sol);
disp_vec = [nodes',approx_sol',true_sol',error'];
disp('Global error at each time step');
disp('     t_i      w(i)        y(ti)     |y(ti) - w(i)|');
disp(disp_vec);

%demonstrating rate of convergence
n=10;
approx_sol=[];
approx_sol_vec=[];
error_vec =[];
true_sol = feval('true_solution',6); %true solution at t=6
for i=1:8
    approx_sol = approx_ode('f',a,b,initial_value,n,test_case);
    approx_sol_vec=[approx_sol_vec;approx_sol(n+1)];
    error = abs(true_sol-approx_sol(n+1));
    error_vec =[error_vec;error];
    n=2*n;
end

ratios= error_vec(1:length(error_vec)-1)./error_vec(2:length(error_vec));
disp_vec = [approx_sol_vec,error_vec];
disp('Approx sol   Global Error at final time')
disp(disp_vec);
disp('ratios');
disp(ratios);
    
    
    

